package org.tbasket.db

import io.getquill.context.ZioJdbc.{DataSourceLayer, QuillZioExt}
import io.getquill.{Literal, SqliteZioJdbcContext}
import org.sqlite.SQLiteDataSource
import org.tbasket.db.schemas.User
import zio._
import zio.console._

import java.io.Closeable
import java.util.Properties
import javax.sql

class Database(config: Properties) {
    
    private val source = new SQLiteDataSource() with Closeable {
        override def close(): Unit = ()
    }
    
    source.setUrl(config.getProperty("database.url"))
    val layer = DataSourceLayer.fromDataSource(source)
    
}

object Database {
    val ctx = new SqliteZioJdbcContext(Literal)
    
    import ctx._
    
    
    val app: ZIO[Console with Has[sql.DataSource with Closeable], Exception, Unit] =
        for {
            _ <- ctx.run(
                quote {
                    liftQuery(List(User(4, "batista", "maxime", 788872465, "myemail@gmail.com")))
                        .foreach(r => User.schema.insert(r))
                }
            ).onDS
            result <- ctx.run(
                quote(User.schema.filter(_.name == "batista"))
            ).onDS
            _ <- putStrLn(s"result : $result")
        } yield ()
    
}

